<script language="JavaScript" type="text/javascript">
<!--

function checkedCount()
{
    numChecked = 0;
    for (var i = 0; i < document.manager.elements.length; i++) {
        if (document.manager.elements[i].checked) {
            numChecked++;
        }
    }
    return numChecked;
}

function getSelected()
{
    var sel = '';
    for (var i = 0; i < document.manager.elements.length; i++) {
        if (document.manager.elements[i].name == 'items[]') {
            if (document.manager.elements[i].checked == 1) {
                sel += document.manager.elements[i].value + "\n";
            }
        }
    }

    if (sel.charAt(sel.length - 1) == "\n") {
        sel = sel.substring(0, sel.length - 1);
    }

    return sel;
}

function getNumItems()
{
    var numItems = 0;
    for (var i = 0; i < document.manager.elements.length; i++) {
        if (document.manager.elements[i].name == 'items[]') {
            numItems++;
        }
    }

    return numItems;
}

function getItemsArray()
{
    var itemsArray = new Array(getNumItems() * 3);
    var arrayPointer = 0;
    for (var i = 0; i < document.manager.elements.length; i++) {
        if (document.manager.elements[i].name == 'items[]') {
            itemsArray[arrayPointer] = document.manager.elements[i].checked;
            itemsArray[arrayPointer+1] = document.manager.elements[i].value;
            arrayPointer += 3;
        }
    }
    arrayPointer = 2;
    for (var i = 0; i < document.manager.elements.length; i++) {
        if (document.manager.elements[i].name == 'itemTypes[]') {
            itemsArray[arrayPointer] = document.manager.elements[i].value;
            arrayPointer += 3;
        }
    }

    return itemsArray;
}

function getSelectedFoldersList()
{
    var selectedFolders = '';
    var itemsArray = getItemsArray();
    for (var i = 0; i < itemsArray.length; i += 3) {
        if (itemsArray[i] && itemsArray[i + 2] == '**dir') {
            selectedFolders += itemsArray[i + 1] + '\n';
        }
    }

    if (selectedFolders.length > 0) {
        if (selectedFolders.charAt(selectedFolders.length - 1) == "\n") {
            selectedFolders = selectedFolders.substring(0, selectedFolders.length - 1);
        }
    }

    return selectedFolders;
}

function AnySelected()
{
    for (i = 0; i < document.manager.elements.length; i++) {
        if (document.manager.elements[i].checked) return true;
    }
    return false;
}

function chooseAction(i)
{
    if (i == 1) {
        action = document.manager.action1.options[document.manager.action1.selectedIndex].value;
    } else {
        action = document.manager.action2.options[document.manager.action2.selectedIndex].value;
    }

    if (action == 'create_folder') {
        createFolder();
    } else if (action == 'change_directory') {
        changeDirectory();
    } else if (action == 'paste_items') {
        pasteItems();
    } else if (checkedCount() == 0) {
        alert('<?php echo addslashes(_("Please select an item before this action.")) ?>');
    } else if (action == 'rename_items') {
        renameItems();
    } else if (action == 'delete_items') {
        deleteItems();
    } else if (action == 'chmod_modify') {
        chmodItems();
    } else if (action == 'cut_items') {
        cutItems();
    } else if (action == 'copy_items') {
        copyItems();
    }
}

function createFolder()
{
    for (var i = 0; i < document.manager.elements.length; i++) {
        if (document.manager.elements[i].checked) {
            document.manager.elements[i].checked = false;
        }
    }

    var popup = document.getElementById('createfolder');
    popup.style.visibility = 'visible';
    document.createfrm.foldername.focus();
}

function changeDirectory()
{
    for (var i = 0; i < document.manager.elements.length; i++) {
        if (document.manager.elements[i].checked) {
            document.manager.elements[i].checked = false;
        }
    }

    var popup = document.getElementById('changedirectory');
    popup.style.visibility = 'visible';
    document.cdfrm.foldername.focus();
}

function renameItems()
{
    var found = false;

    // Find first file to rename.
    for (var i = 0; i < document.manager.elements.length; i++) {
        if (document.manager.elements[i].name == "items[]" &&
            document.manager.elements[i].checked) {
            document.manager.elements[i].checked = false;
            document.renamefrm.oldname.value = document.manager.elements[i].value;
            document.renamefrm.newname.value = document.manager.elements[i].value;
            found = true;
            break;
        }
    }

    if (found) {
        var popup = document.getElementById('rename');
        popup.style.visibility = 'visible';
        document.renamefrm.newname.focus();
    }
}

function deleteItems()
{
    var cont = false;

    if (window.confirm('<?php echo addslashes(_("The following items will be permanently deleted: ")) ?>\n' + getSelected() + '\n<?php echo addslashes(_("Are you sure?")) ?>')) {
    <?php if ($prefs->getValue('recursive_deletes') == 'warn'): ?>
        var selectedFolders = getSelectedFoldersList();
        if (selectedFolders.length > 0) {
            if (window.confirm('<?php echo addslashes(_("The following item(s) are folders: ")) ?>\n' + selectedFolders + '\n<?php echo addslashes(_("Are you sure you wish to continue?")) ?>')) {
                cont = true;
            }
        } else {
            cont = true;
        }
    <?php else: ?>
        cont = true;
    <?php endif; ?>
    }

    if (cont) {
        document.manager.actionID.value = 'delete_items';
        document.manager.submit();
    }
}

function chmodItems()
{
    var popup = document.getElementById('attributes');
    popup.style.visibility = 'visible';
}

function cutItems()
{
    document.manager.actionID.value = 'cut_items';
    document.manager.submit();
}

function copyItems()
{
    document.manager.actionID.value = 'copy_items';
    document.manager.submit();
}

function pasteItems()
{
    document.manager.actionID.value = 'paste_items';
    document.manager.submit();
}

function uploadFile()
{
    if (document.manager.file_upload_1.value == '' &&
        document.manager.file_upload_2.value == '' &&
        document.manager.file_upload_3.value == '') {
        alert('<?php echo addslashes(_("Please specify at least one file to upload.")) ?>');
        document.manager.file_upload_1.focus ();
    } else {
        document.manager.actionID.value = 'upload_file';
        document.manager.submit();
    }
}

function toggleSelection()
{
    var total = 0;
    var checked = 0;
    for (var i = 0; i < document.manager.elements.length; i++) {
        if (document.manager.elements[i].name == "items[]") {
            total++;
            if (document.manager.elements[i].checked) {
                checked++;
            }
        }
    }

    var new_value = (total != checked);
    for (var i = 0; i < document.manager.elements.length; i++) {
        if (document.manager.elements[i].name == "items[]") {
            document.manager.elements[i].checked = new_value;
        }
    }
}

function createfolderOK()
{
    var popup = document.getElementById('createfolder');
    popup.style.visibility = 'hidden';

    if (document.createfrm.foldername.value != '') {
        document.manager.new_folder.value = document.createfrm.foldername.value;
        document.manager.actionID.value = 'create_folder';
        document.manager.submit();
    }
}

function createfolderKeyCheck(event)
{
    if (event.keyCode == 27) {
        createfolderCancel();
        return false;
    } else if (event.keyCode == 13) {
        createfolderOK();
        return false;
    }
    return true;
}

function createfolderCancel()
{
    var popup = document.getElementById('createfolder');
    popup.style.visibility = 'hidden';
    document.createfrm.reset();
}

function chmodCancel()
{
    document.chmodfrm.reset();
    var popup = document.getElementById('attributes');
    popup.style.visibility = 'hidden';
}

function chmodSave()
{
    owner = 0;
    group = 0;
    all = 0;

    for (var i = 0; i < document.chmodfrm.elements.length; i++) {
        if (document.chmodfrm.elements[i].name == "owner[]" && document.chmodfrm.elements[i].checked) {
            owner |= document.chmodfrm.elements[i].value;
        }
        else if (document.chmodfrm.elements[i].name == "group[]" && document.chmodfrm.elements[i].checked) {
            group |= document.chmodfrm.elements[i].value;
        }
        else if (document.chmodfrm.elements[i].name == "all[]" && document.chmodfrm.elements[i].checked) {
            all |= document.chmodfrm.elements[i].value;
        }
    }

    var popup = document.getElementById('attributes');
    popup.style.visibility = 'hidden';

    document.manager.chmod.value = "0" + owner + "" + group + "" + all;
    document.manager.actionID.value = 'chmod_modify';
    document.manager.submit();
}

function renameOK()
{
    var newNames = document.manager.new_names.value;
    var oldNames = document.manager.old_names.value;

    if (document.renamefrm.newname.value != '' &&
        document.renamefrm.newname.value != document.renamefrm.oldname.value) {
        newNames += "|" + document.renamefrm.newname.value;
        oldNames += "|" + document.renamefrm.oldname.value;
    }

    if (newNames.charAt(0) == "|") {
        newNames = newNames.substring(1);
    }
    if (oldNames.charAt(0) == "|") {
        oldNames = oldNames.substring(1);
    }

    document.manager.new_names.value = newNames;
    document.manager.old_names.value = oldNames;

    var found = false;

    // See if there are any more files to rename.
    for (var i = 0; i < document.manager.elements.length; i++) {
        if (document.manager.elements[i].name == "items[]" && document.manager.elements[i].checked) {
            document.manager.elements[i].checked = false;
            document.renamefrm.oldname.value = document.manager.elements[i].value;
            document.renamefrm.newname.value = document.manager.elements[i].value;
            found = true;
            break;
        }
    }

    if (found) {
        var popup = document.getElementById('rename');
        popup.style.visibility = 'visible';
        document.renamefrm.newname.focus();
    } else {
        document.manager.actionID.value = 'rename_items';
        document.manager.submit();
    }

    return false;
}

function renameCancel()
{
    document.manager.new_names.value = '';
    document.manager.old_names.value = '';

    var popup = document.getElementById('rename');
    popup.style.visibility = 'hidden';
}

function renameKeyCheck(event)
{
    if (event.keyCode == 13) {
        renameOK();
        return false;
    }
    if (event.keyCode == 27) {
        renameCancel();
        return false;
    }
    return true;
}

function changedirectoryOK()
{
    var popup = document.getElementById('changedirectory');
    popup.style.visibility = 'hidden';

    if (document.cdfrm.foldername.value != '') {
        document.manager.dir.value = document.cdfrm.foldername.value;
        document.manager.submit();
    }
}

function changedirectoryKeyCheck(event)
{
    if (event.keyCode == 27) {
        changedirectoryCancel();
        return false;
    } else if (event.keyCode == 13) {
        changedirectoryOK();
        return false;
    }
    return true;
}

function changedirectoryCancel()
{
    var popup = document.getElementById('changedirectory');
    popup.style.visibility = 'hidden';
    document.cdfrm.reset();
}

// -->
</script>

<div id="attributes" style="background-color:black;position:absolute;left:200px;top:20px;width:200px;visibility:hidden;padding:1px">
<?php
// FIXME probably should add a function to Gollem:: to get this.
$attrib = $GLOBALS['vfs']->getModifiablePermissions();
?>
    <form name="chmodfrm">
    <table width="100%" cellspacing="0" class="text">
    <tr>
        <td width="100%" class="header" align="center" colspan="4">
            <?php echo _("Attributes") ?>
        </td>
    <tr class="control">
        <td align="center" width="25%"></td>
        <td align="center" width="25%" class="smallheader"><?php echo _("Owner") ?></td>
        <td align="center" width="25%" class="smallheader"><?php echo _("Group") ?></td>
        <td align="center" width="25%" class="smallheader"><?php echo _("All") ?></td>
    </tr>
    <tr class="control">
        <td align="center" width="25%"><?php echo _("Read") ?></td>
        <td align="center" width="25%"><input name="owner[]" type="checkbox" value="4"<?php echo ($attrib['owner']['read']) ? '' : ' disabled="disabled"' ?> /></td>
        <td align="center" width="25%"><input name="group[]" type="checkbox" value="4"<?php echo ($attrib['group']['read']) ? '' : ' disabled="disabled"' ?> /></td>
        <td align="center" width="25%"><input name="all[]" type="checkbox" value="4"<?php echo ($attrib['all']['read']) ? '' : ' disabled="disabled"' ?> /></td>
    </tr>
    <tr class="control">
        <td align="center" width="25%"><?php echo _("Write") ?></td>
        <td align="center" width="25%"><input name="owner[]" type="checkbox" value="2"<?php echo ($attrib['owner']['write']) ? '' : ' disabled="disabled"' ?> /></td>
        <td align="center" width="25%"><input name="group[]" type="checkbox" value="2"<?php echo ($attrib['group']['write']) ? '' : ' disabled="disabled"' ?> /></td>
        <td align="center" width="25%"><input name="all[]" type="checkbox" value="2"<?php echo ($attrib['all']['write']) ? '' : ' disabled="disabled"' ?> /></td>
    </tr>
    <tr class="control">
        <td align="center" width="25%"><?php echo _("Execute") ?></td>
        <td align="center" width="25%"><input name="owner[]" type="checkbox" value="1"<?php echo ($attrib['owner']['execute']) ? '' : ' disabled="disabled"' ?> /></td>
        <td align="center" width="25%"><input name="group[]" type="checkbox" value="1"<?php echo ($attrib['group']['execute']) ? '' : ' disabled="disabled"' ?> /></td>
        <td align="center" width="25%"><input name="all[]" type="checkbox" value="1"<?php echo ($attrib['all']['execute']) ? '' : ' disabled="disabled"' ?> /></td>
    </tr>
    <tr class="control">
        <td align="center" width="50%" colspan="2"><input class="button" type="button" name="Save" value="<?php echo _("Save") ?>" onclick="chmodSave();"></td>
        <td align="center" width="50%" colspan="2"><input class="button" type="button" name="Cancel" value="<?php echo _("Cancel") ?>" onclick="chmodCancel()"></td>
    </tr>
    <tr class="control">
        <td align="center" width="100%" colspan="4" height="5"></td>
    </tr>
    </table>
    </form>
</div>
<div id="rename" style="background-color:black;position:absolute;left:200px;top:20px;width:200px;visibility:hidden;padding:1px">
    <form name="renamefrm">
    <input type="hidden" name="oldname" value="" />
    <table width="100%" cellspacing="0" class="text">
    <tr>
        <td width="100%" class="header" align="center" colspan="4">
            <?php echo _("Rename") ?>
        </td>
    </tr>
    <tr class="control">
        <td align="center" width="100%" colspan="4" height="5"></td>
    </tr>
    <tr class="control">
        <td align="right" width="35%">
            <?php echo _("Name:") ?>&nbsp;
        </td>
        <td align="center" colspan="3" width="65%">
            <input class="input" type="text" name="newname" value="" onkeypress="return renameKeyCheck(event);">
        </td>
    </tr>
    <tr class="control">
        <td align="center" width="100%" colspan="4" height="5"></td>
    </tr>
    <tr class="control">
        <td align="center" width="50%" colspan="2"><input class="button" type="button" value="<?php echo _("OK") ?>" onclick="renameOK();"></td>
        <td align="center" width="50%" colspan="2"><input class="button" type="button" value="<?php echo _("Cancel") ?>" onclick="renameCancel()"></td>
    </tr>
    <tr class="control">
        <td align="center" width="100%" colspan="4" height="5"></td>
    </tr>
    </table>
    </form>
</div>
<div id="createfolder" style="background-color:black;position:absolute;left:200px;top:20px;width:200px;visibility:hidden;padding:1px">
    <form name="createfrm" onsubmit="return false;">
    <table width="100%" cellspacing="0" class="text">
    <tr>
        <td width="100%" class="header" align="center" colspan="4">
            <?php echo _("Create Folder") ?>
        </td>
    </tr>
    <tr class="control">
        <td align="center" width="100%" colspan="4" height="5"></td>
    </tr>
    <tr class="control">
        <td align="right" width="35%">
            <?php echo _("Name:") ?>&nbsp;
        </td>
        <td align="center" colspan="3" width="65%">
            <input class="input" type="text" name="foldername" value="" onkeypress="return createfolderKeyCheck(event)">
        </td>
    </tr>
    <tr class="control">
        <td align="center" width="100%" colspan="4" height="5"></td>
    </tr>
    <tr class="control">
        <td align="center" width="50%" colspan="2"><input class="button" type="button" value="<?php echo _("OK") ?>" onclick="createfolderOK();"></td>
        <td align="center" width="50%" colspan="2"><input class="button" type="button" value="<?php echo _("Cancel") ?>" onclick="createfolderCancel()"></td>
    </tr>
    <tr class="control">
        <td align="center" width="100%" colspan="4" height="5"></td>
    </tr>
    </table>
    </form>
</div>
<div id="changedirectory" style="background-color:black;position:absolute;left:200px;top:20px;width:200px;visibility:hidden;padding:1px">
    <form name="cdfrm" onsubmit="return false;">
    <table width="100%" cellspacing="0" class="text">
    <tr>
        <td width="100%" class="header" align="center" colspan="4">
            <?php echo _("Change Folder") ?>
        </td>
    </tr>
    <tr class="control">
        <td align="center" width="100%" colspan="4" height="5"></td>
    </tr>
    <tr class="control">
        <td align="right" width="35%" nowrap="nowrap">
            <?php echo _("Go to:") ?>&nbsp;
        </td>
        <td align="center" colspan="3" width="65%">
            <input class="input" type="text" name="foldername" value="" onkeypress="return changedirectoryKeyCheck(event)">
        </td>
    </tr>
    <tr class="control">
        <td align="center" width="100%" colspan="4" height="5"></td>
    </tr>
    <tr class="control">
        <td align="center" width="50%" colspan="2"><input class="button" type="button" value="<?php echo _("OK") ?>" onclick="changedirectoryOK();"></td>
        <td align="center" width="50%" colspan="2"><input class="button" type="button" value="<?php echo _("Cancel") ?>" onclick="changedirectoryCancel()"></td>
    </tr>
    <tr class="control">
        <td align="center" width="100%" colspan="4" height="5"></td>
    </tr>
    </table>
    </form>
</div>

<form method="post" name="manager" enctype="multipart/form-data" action="<?php echo $manager_url ?>">
<?php echo Util::formInput() ?>
<input type="hidden" name="actionID" value="" />
<input type="hidden" name="new_folder" value="" />
<input type="hidden" name="new_names" value="" />
<input type="hidden" name="old_names" value="" />
<input type="hidden" name="chmod" value="" />
<input type="hidden" name="dir" value="<?php echo $currdir ?>" />
<table width="100%" cellspacing="0">
<tr><td>
<table width="100%" cellspacing="0">
<tr>
  <td align="left" width="40%" class="header">
    <b><?php echo Gollem::directoryNavLink($currdir, $manager_url) ?></b>
    <?php echo Horde::link(Horde::selfUrl(), sprintf("%s %s", _("Refresh"), $_SESSION['gollem']['label'])) . Horde::img('reload.png', sprintf("%s %s", _("Refresh"), htmlspecialchars($_SESSION['gollem']['label'])), null, $GLOBALS['registry']->getImageDir('horde')) ?></a>
  </td>
  <td align="right" class="header">
    <b><?php echo ((count($list) == 1) ? _("1 item") : sprintf(_("%d items"), count($list))) ?></b>
  </td>
</tr>
</table>
</td></tr>
<tr class="item"><td>
<table width="100%" cellspacing="0">
  <tr>
<?php if (Gollem::checkPermissions('backend', PERMS_EDIT)): ?>
    <td width="40%" align="left" nowrap="nowrap">
      <table cellspacing="0">
        <tr>
          <td><b><?php echo _("File 1:") ?></b></td>
          <td>&nbsp;<input name="file_upload_1" type="file" size="20" class="fixed" /></td>
          <td rowspan="3">
            &nbsp;<input type="button" class="button" onclick="uploadFile()" value="<?php echo _("Upload File(s)") ?>" />
            &nbsp;<?php echo Help::link('gollem', 'file-upload') ?>
        </tr>
        <tr>
          <td><b><?php echo _("File 2:") ?></b></td>
          <td>&nbsp;<input name="file_upload_2" type="file" size="20" class="fixed" /></td>
        </tr>
        <tr>
          <td><b><?php echo _("File 3:") ?></b></td>
          <td>&nbsp;<input name="file_upload_3" type="file" size="20" class="fixed" /></td>
        </tr>
      </table>
    </td>
<?php endif; ?>

    <td align="right" nowrap="nowrap">
      <?php echo Help::link('gollem', 'file-actions') ?>
      <select name="action1" onchange="chooseAction(1); document.manager.action1.selectedIndex = 0;">
        <option selected="selected"><?php echo _("Choose Action:") ?></option>
<?php if (Gollem::checkPermissions('backend', PERMS_READ)): ?>
            <option value="change_directory"><?php echo _("Change Folder") ?></option>
<?php endif; ?>
<?php if (Gollem::checkPermissions('backend', PERMS_EDIT)): ?>
            <option value="create_folder"><?php echo _("Create Folder") ?></option>
<?php endif; ?>
<?php if (@count($list)): ?>
<?php if (Gollem::checkPermissions('backend', PERMS_EDIT)): ?>
            <option value="rename_items"><?php echo _("Rename Items") ?></option>
<?php endif; ?>
<?php if (Gollem::checkPermissions('backend', PERMS_DELETE)): ?>
            <option value="delete_items"><?php echo _("Delete Items") ?></option>
<?php endif; ?>
<?php if (Gollem::checkPermissions('backend', PERMS_EDIT)): ?>
            <option value="chmod_modify"><?php echo _("Chmod Items") ?></option>
<?php if ((empty($_SESSION['gollem']['cut']['selected'])) && (empty($_SESSION['gollem']['copy']['selected']))): ?>
            <option value="cut_items"><?php echo _("Cut Items") ?></option>
            <option value="copy_items"><?php echo _("Copy Items") ?></option>
<?php endif; ?>
<?php endif; ?>
<?php endif; ?>
<?php if (Gollem::checkPermissions('backend', PERMS_EDIT)): ?>
<?php if ((!empty($_SESSION['gollem']['cut']['selected'])) || (!empty($_SESSION['gollem']['copy']['selected']))): ?>
            <option value="paste_items"><?php echo _("Paste Items") ?></option>
<?php endif; ?>
<?php endif; ?>
      </select>
    </td>
  </tr>
</table>

<input type="hidden" value="" name="targetFolder" />
</td>
</tr>
